/**
 *  @file main.cpp
 *  @brief a vektor osztályunkat tesztelő program
 */

#include "Vector.h"
#include <iostream>

// Nem "using-oljuk" a teljes névteret, csak amit sokszor használunk
using std::cout;
using std::endl;

int main()
{
	Vector v1(3, 2.4); 	cout << endl;
	Vector v2(3);		cout << endl;
	Vector v3(3);		cout << endl;
	v1[1] = 3.4; v1[2] = -4.1;
	v3[1] = -4; v3[2] = 9.3;
	
	cout << "v1 = " << v1 << endl;
	cout << "v2 = " << v1 << endl;

	cout << "Computing: v3 = v1 + v2 + v3" << endl;
	// Milyen függvények hívódnak?
	v3 = v1 + v2 + v3; cout << endl;
	cout << "v3 = " << v3 << endl;
	
	// Kivételek kipróbálása
	try {
		v1[6] = 17;
	} 
	catch (char const* msg) {
		cout << "I cought this: " << msg << std::endl;
	}
	
	// Kivételek kipróbálása
	try {
		size_t very_big_size = 1 << 31;
		Vector v_big(very_big_size, 1.0);
	} 
	catch (std::bad_alloc const& ba) {
		// A .what() tagfüggvény mondja 
		cout << "I cought this: " << ba.what() << std::endl;
	}
	
	cout << "Bye-bye!" << endl;
	return 0;
}